# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'InstanceIamBindingCondition',
    'InstanceIamMemberCondition',
    'NotificationConfigStreamingConfig',
    'ProjectCustomModuleCustomConfig',
    'ProjectCustomModuleCustomConfigCustomOutput',
    'ProjectCustomModuleCustomConfigCustomOutputProperty',
    'ProjectCustomModuleCustomConfigCustomOutputPropertyValueExpression',
    'ProjectCustomModuleCustomConfigPredicate',
    'ProjectCustomModuleCustomConfigResourceSelector',
    'SourceIamBindingCondition',
    'SourceIamMemberCondition',
]

@pulumi.output_type
class InstanceIamBindingCondition(dict):
    def __init__(__self__, *,
                 expression: str,
                 title: str,
                 description: Optional[str] = None):
        """
        :param str description: An optional description of the instance.
        """
        InstanceIamBindingCondition._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            expression=expression,
            title=title,
            description=description,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             expression: str,
             title: str,
             description: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("expression", expression)
        _setter("title", title)
        if description is not None:
            _setter("description", description)

    @property
    @pulumi.getter
    def expression(self) -> str:
        return pulumi.get(self, "expression")

    @property
    @pulumi.getter
    def title(self) -> str:
        return pulumi.get(self, "title")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        An optional description of the instance.
        """
        return pulumi.get(self, "description")


@pulumi.output_type
class InstanceIamMemberCondition(dict):
    def __init__(__self__, *,
                 expression: str,
                 title: str,
                 description: Optional[str] = None):
        """
        :param str description: An optional description of the instance.
        """
        InstanceIamMemberCondition._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            expression=expression,
            title=title,
            description=description,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             expression: str,
             title: str,
             description: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("expression", expression)
        _setter("title", title)
        if description is not None:
            _setter("description", description)

    @property
    @pulumi.getter
    def expression(self) -> str:
        return pulumi.get(self, "expression")

    @property
    @pulumi.getter
    def title(self) -> str:
        return pulumi.get(self, "title")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        An optional description of the instance.
        """
        return pulumi.get(self, "description")


@pulumi.output_type
class NotificationConfigStreamingConfig(dict):
    def __init__(__self__, *,
                 filter: str):
        """
        :param str filter: Expression that defines the filter to apply across create/update
               events of assets or findings as specified by the event type. The
               expression is a list of zero or more restrictions combined via
               logical operators AND and OR. Parentheses are supported, and OR
               has higher precedence than AND.
               Restrictions have the form <field> <operator> <value> and may have
               a - character in front of them to indicate negation. The fields
               map to those defined in the corresponding resource.
               The supported operators are:
               * = for all value types.
               * >, <, >=, <= for integer values.
               * :, meaning substring matching, for strings.
               The supported value types are:
               * string literals in quotes.
               * integer literals without quotes.
               * boolean literals true and false without quotes.
               See
               [Filtering notifications](https://cloud.google.com/security-command-center/docs/how-to-api-filter-notifications)
               for information on how to write a filter.
               
               - - -
        """
        NotificationConfigStreamingConfig._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            filter=filter,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             filter: str,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("filter", filter)

    @property
    @pulumi.getter
    def filter(self) -> str:
        """
        Expression that defines the filter to apply across create/update
        events of assets or findings as specified by the event type. The
        expression is a list of zero or more restrictions combined via
        logical operators AND and OR. Parentheses are supported, and OR
        has higher precedence than AND.
        Restrictions have the form <field> <operator> <value> and may have
        a - character in front of them to indicate negation. The fields
        map to those defined in the corresponding resource.
        The supported operators are:
        * = for all value types.
        * >, <, >=, <= for integer values.
        * :, meaning substring matching, for strings.
        The supported value types are:
        * string literals in quotes.
        * integer literals without quotes.
        * boolean literals true and false without quotes.
        See
        [Filtering notifications](https://cloud.google.com/security-command-center/docs/how-to-api-filter-notifications)
        for information on how to write a filter.

        - - -
        """
        return pulumi.get(self, "filter")


@pulumi.output_type
class ProjectCustomModuleCustomConfig(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "resourceSelector":
            suggest = "resource_selector"
        elif key == "customOutput":
            suggest = "custom_output"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ProjectCustomModuleCustomConfig. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ProjectCustomModuleCustomConfig.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ProjectCustomModuleCustomConfig.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 predicate: 'outputs.ProjectCustomModuleCustomConfigPredicate',
                 recommendation: str,
                 resource_selector: 'outputs.ProjectCustomModuleCustomConfigResourceSelector',
                 severity: str,
                 custom_output: Optional['outputs.ProjectCustomModuleCustomConfigCustomOutput'] = None,
                 description: Optional[str] = None):
        """
        :param 'ProjectCustomModuleCustomConfigPredicateArgs' predicate: The CEL expression to evaluate to produce findings. When the expression evaluates
               to true against a resource, a finding is generated.
               Structure is documented below.
        :param str recommendation: An explanation of the recommended steps that security teams can take to resolve
               the detected issue. This explanation is returned with each finding generated by
               this module in the nextSteps property of the finding JSON.
        :param 'ProjectCustomModuleCustomConfigResourceSelectorArgs' resource_selector: The resource types that the custom module operates on. Each custom module
               can specify up to 5 resource types.
               Structure is documented below.
        :param str severity: The severity to assign to findings generated by the module.
               Possible values are: `CRITICAL`, `HIGH`, `MEDIUM`, `LOW`.
        :param 'ProjectCustomModuleCustomConfigCustomOutputArgs' custom_output: Custom output properties.
               Structure is documented below.
        :param str description: Text that describes the vulnerability or misconfiguration that the custom
               module detects. This explanation is returned with each finding instance to
               help investigators understand the detected issue. The text must be enclosed in quotation marks.
        """
        ProjectCustomModuleCustomConfig._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            predicate=predicate,
            recommendation=recommendation,
            resource_selector=resource_selector,
            severity=severity,
            custom_output=custom_output,
            description=description,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             predicate: 'outputs.ProjectCustomModuleCustomConfigPredicate',
             recommendation: str,
             resource_selector: 'outputs.ProjectCustomModuleCustomConfigResourceSelector',
             severity: str,
             custom_output: Optional['outputs.ProjectCustomModuleCustomConfigCustomOutput'] = None,
             description: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("predicate", predicate)
        _setter("recommendation", recommendation)
        _setter("resource_selector", resource_selector)
        _setter("severity", severity)
        if custom_output is not None:
            _setter("custom_output", custom_output)
        if description is not None:
            _setter("description", description)

    @property
    @pulumi.getter
    def predicate(self) -> 'outputs.ProjectCustomModuleCustomConfigPredicate':
        """
        The CEL expression to evaluate to produce findings. When the expression evaluates
        to true against a resource, a finding is generated.
        Structure is documented below.
        """
        return pulumi.get(self, "predicate")

    @property
    @pulumi.getter
    def recommendation(self) -> str:
        """
        An explanation of the recommended steps that security teams can take to resolve
        the detected issue. This explanation is returned with each finding generated by
        this module in the nextSteps property of the finding JSON.
        """
        return pulumi.get(self, "recommendation")

    @property
    @pulumi.getter(name="resourceSelector")
    def resource_selector(self) -> 'outputs.ProjectCustomModuleCustomConfigResourceSelector':
        """
        The resource types that the custom module operates on. Each custom module
        can specify up to 5 resource types.
        Structure is documented below.
        """
        return pulumi.get(self, "resource_selector")

    @property
    @pulumi.getter
    def severity(self) -> str:
        """
        The severity to assign to findings generated by the module.
        Possible values are: `CRITICAL`, `HIGH`, `MEDIUM`, `LOW`.
        """
        return pulumi.get(self, "severity")

    @property
    @pulumi.getter(name="customOutput")
    def custom_output(self) -> Optional['outputs.ProjectCustomModuleCustomConfigCustomOutput']:
        """
        Custom output properties.
        Structure is documented below.
        """
        return pulumi.get(self, "custom_output")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        Text that describes the vulnerability or misconfiguration that the custom
        module detects. This explanation is returned with each finding instance to
        help investigators understand the detected issue. The text must be enclosed in quotation marks.
        """
        return pulumi.get(self, "description")


@pulumi.output_type
class ProjectCustomModuleCustomConfigCustomOutput(dict):
    def __init__(__self__, *,
                 properties: Optional[Sequence['outputs.ProjectCustomModuleCustomConfigCustomOutputProperty']] = None):
        """
        :param Sequence['ProjectCustomModuleCustomConfigCustomOutputPropertyArgs'] properties: A list of custom output properties to add to the finding.
               Structure is documented below.
        """
        ProjectCustomModuleCustomConfigCustomOutput._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            properties=properties,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             properties: Optional[Sequence['outputs.ProjectCustomModuleCustomConfigCustomOutputProperty']] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        if properties is not None:
            _setter("properties", properties)

    @property
    @pulumi.getter
    def properties(self) -> Optional[Sequence['outputs.ProjectCustomModuleCustomConfigCustomOutputProperty']]:
        """
        A list of custom output properties to add to the finding.
        Structure is documented below.
        """
        return pulumi.get(self, "properties")


@pulumi.output_type
class ProjectCustomModuleCustomConfigCustomOutputProperty(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "valueExpression":
            suggest = "value_expression"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ProjectCustomModuleCustomConfigCustomOutputProperty. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ProjectCustomModuleCustomConfigCustomOutputProperty.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ProjectCustomModuleCustomConfigCustomOutputProperty.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 name: Optional[str] = None,
                 value_expression: Optional['outputs.ProjectCustomModuleCustomConfigCustomOutputPropertyValueExpression'] = None):
        """
        :param str name: Name of the property for the custom output.
        :param 'ProjectCustomModuleCustomConfigCustomOutputPropertyValueExpressionArgs' value_expression: The CEL expression for the custom output. A resource property can be specified
               to return the value of the property or a text string enclosed in quotation marks.
               Structure is documented below.
        """
        ProjectCustomModuleCustomConfigCustomOutputProperty._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            value_expression=value_expression,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             value_expression: Optional['outputs.ProjectCustomModuleCustomConfigCustomOutputPropertyValueExpression'] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        if name is not None:
            _setter("name", name)
        if value_expression is not None:
            _setter("value_expression", value_expression)

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Name of the property for the custom output.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="valueExpression")
    def value_expression(self) -> Optional['outputs.ProjectCustomModuleCustomConfigCustomOutputPropertyValueExpression']:
        """
        The CEL expression for the custom output. A resource property can be specified
        to return the value of the property or a text string enclosed in quotation marks.
        Structure is documented below.
        """
        return pulumi.get(self, "value_expression")


@pulumi.output_type
class ProjectCustomModuleCustomConfigCustomOutputPropertyValueExpression(dict):
    def __init__(__self__, *,
                 expression: str,
                 description: Optional[str] = None,
                 location: Optional[str] = None,
                 title: Optional[str] = None):
        """
        :param str expression: Textual representation of an expression in Common Expression Language syntax.
        :param str description: Description of the expression. This is a longer text which describes the
               expression, e.g. when hovered over it in a UI.
        :param str location: String indicating the location of the expression for error reporting, e.g. a
               file name and a position in the file.
        :param str title: Title for the expression, i.e. a short string describing its purpose. This can
               be used e.g. in UIs which allow to enter the expression.
        """
        ProjectCustomModuleCustomConfigCustomOutputPropertyValueExpression._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            expression=expression,
            description=description,
            location=location,
            title=title,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             expression: str,
             description: Optional[str] = None,
             location: Optional[str] = None,
             title: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("expression", expression)
        if description is not None:
            _setter("description", description)
        if location is not None:
            _setter("location", location)
        if title is not None:
            _setter("title", title)

    @property
    @pulumi.getter
    def expression(self) -> str:
        """
        Textual representation of an expression in Common Expression Language syntax.
        """
        return pulumi.get(self, "expression")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        Description of the expression. This is a longer text which describes the
        expression, e.g. when hovered over it in a UI.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def location(self) -> Optional[str]:
        """
        String indicating the location of the expression for error reporting, e.g. a
        file name and a position in the file.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def title(self) -> Optional[str]:
        """
        Title for the expression, i.e. a short string describing its purpose. This can
        be used e.g. in UIs which allow to enter the expression.
        """
        return pulumi.get(self, "title")


@pulumi.output_type
class ProjectCustomModuleCustomConfigPredicate(dict):
    def __init__(__self__, *,
                 expression: str,
                 description: Optional[str] = None,
                 location: Optional[str] = None,
                 title: Optional[str] = None):
        """
        :param str expression: Textual representation of an expression in Common Expression Language syntax.
        :param str description: Description of the expression. This is a longer text which describes the
               expression, e.g. when hovered over it in a UI.
        :param str location: String indicating the location of the expression for error reporting, e.g. a
               file name and a position in the file.
        :param str title: Title for the expression, i.e. a short string describing its purpose. This can
               be used e.g. in UIs which allow to enter the expression.
        """
        ProjectCustomModuleCustomConfigPredicate._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            expression=expression,
            description=description,
            location=location,
            title=title,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             expression: str,
             description: Optional[str] = None,
             location: Optional[str] = None,
             title: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("expression", expression)
        if description is not None:
            _setter("description", description)
        if location is not None:
            _setter("location", location)
        if title is not None:
            _setter("title", title)

    @property
    @pulumi.getter
    def expression(self) -> str:
        """
        Textual representation of an expression in Common Expression Language syntax.
        """
        return pulumi.get(self, "expression")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        Description of the expression. This is a longer text which describes the
        expression, e.g. when hovered over it in a UI.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def location(self) -> Optional[str]:
        """
        String indicating the location of the expression for error reporting, e.g. a
        file name and a position in the file.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def title(self) -> Optional[str]:
        """
        Title for the expression, i.e. a short string describing its purpose. This can
        be used e.g. in UIs which allow to enter the expression.
        """
        return pulumi.get(self, "title")


@pulumi.output_type
class ProjectCustomModuleCustomConfigResourceSelector(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "resourceTypes":
            suggest = "resource_types"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ProjectCustomModuleCustomConfigResourceSelector. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ProjectCustomModuleCustomConfigResourceSelector.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ProjectCustomModuleCustomConfigResourceSelector.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 resource_types: Sequence[str]):
        """
        :param Sequence[str] resource_types: The resource types to run the detector on.
               
               - - -
        """
        ProjectCustomModuleCustomConfigResourceSelector._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            resource_types=resource_types,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             resource_types: Sequence[str],
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("resource_types", resource_types)

    @property
    @pulumi.getter(name="resourceTypes")
    def resource_types(self) -> Sequence[str]:
        """
        The resource types to run the detector on.

        - - -
        """
        return pulumi.get(self, "resource_types")


@pulumi.output_type
class SourceIamBindingCondition(dict):
    def __init__(__self__, *,
                 expression: str,
                 title: str,
                 description: Optional[str] = None):
        """
        :param str description: The description of the source (max of 1024 characters).
        """
        SourceIamBindingCondition._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            expression=expression,
            title=title,
            description=description,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             expression: str,
             title: str,
             description: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("expression", expression)
        _setter("title", title)
        if description is not None:
            _setter("description", description)

    @property
    @pulumi.getter
    def expression(self) -> str:
        return pulumi.get(self, "expression")

    @property
    @pulumi.getter
    def title(self) -> str:
        return pulumi.get(self, "title")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        The description of the source (max of 1024 characters).
        """
        return pulumi.get(self, "description")


@pulumi.output_type
class SourceIamMemberCondition(dict):
    def __init__(__self__, *,
                 expression: str,
                 title: str,
                 description: Optional[str] = None):
        """
        :param str description: The description of the source (max of 1024 characters).
        """
        SourceIamMemberCondition._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            expression=expression,
            title=title,
            description=description,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             expression: str,
             title: str,
             description: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("expression", expression)
        _setter("title", title)
        if description is not None:
            _setter("description", description)

    @property
    @pulumi.getter
    def expression(self) -> str:
        return pulumi.get(self, "expression")

    @property
    @pulumi.getter
    def title(self) -> str:
        return pulumi.get(self, "title")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        The description of the source (max of 1024 characters).
        """
        return pulumi.get(self, "description")


